/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pjv.hodina10;

import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author martin
 */
public class StackImpl implements Stack {
    private static final int SIZE = 3;
    private String[] stackArray = new String[SIZE];
    private int count=0;

    @Override
    public synchronized void add(String word) {
        while (isFull()){
            try {
                wait();
            } catch (InterruptedException ex) {
                Logger.getLogger(StackImpl.class.getName()).log(Level.SEVERE, null, ex);
            }
        }          
        stackArray[count]=word;
        count++;
        notifyAll();
    }

    @Override
    public synchronized String pop() throws InterruptedException {
        while(isEmpty()){
             try {
                wait();
            } catch (InterruptedException ex) {
                Logger.getLogger(StackImpl.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        String res= stackArray[count-1];
        count--;
        notifyAll();
        return res;
    }

    @Override
    public synchronized boolean isEmpty() {
        return (count==0);
    }
    
    public synchronized boolean isFull(){
        return (count>=SIZE);
    }
    
}
